# Tietoa projektitoimeksiantajalle

![](https://openclipart.org/image/300px/svg_to_png/310157/1542098444.png)

Kiitos, kun eksyit tälle sivulle. Kerron lyhyesti, mitä tarkoittaa toimeksiantajan rooli JAMKin ohjelmistotuotannon käytänteet opintokokonaisuudessa. 
Syksyn 2020 aikana ohjelmistotekniikan opiskelijat muodostavat projektiryhmiä, jotka keskittyvät ratkaisemaan erilaisia toimeksiantoja yrityselämästä.

**Ohjelmistotuotannon käytännöt projektin muodossa?**

<iframe width="560" height="315" src="https://www.youtube.com/embed/ZNVAiZncLLc" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>

Kurssin tavoite on kouluttaa JAMK IT-instituutissa opiskelevia opiskelijoita toimimaan projektitiiminä. Tiimin tehtävä on lyhyesti toimittaa toimeksiantajayritykselle/yhteisölle yhdessä sovittu ohjelmistoratkaisu/prototyyppi.

Opiskelijoille on "budjetoitu" projektityötä seuraavasti:

* Opintokokonaisuuksien TTOS1000 + TTOS1200 yhteenlasketut opintopisteet ovat 12 ECTS
* (1 ECTS = 27,5h opiskelua/työskentelyä)
* 2 opintopistettä on jyvitetty yleiseen teoriaan ja luentosarjaan. 
**10 opintopistettä on varattu projektityöskentelyyn! joka tarkoittaa opiskelijalle maksimissaan ~270 h työkuormaa**
* Projektiryhmän koko yleiseti 4-6 henkilöä

## Tiedän jo kaiken! Missä voin kertoa mitä haluan tilata...


Kannattaa vielä käydä läpi alla olevat kohdat, mutta jos sinulla toimeksiantajan on todella kiire 
ja tunnet prosessin jo aimmilta vuosilta niin vastaa Forms-kyselyyn sivun lopussa!

# Syksy 2020 

* Matkaan lähetetään 5-6 projektiryhmää syksyn 2020 aikana. Ryhmät työskentelevät helmikuuhun 2021  
* Opiskelu on oletuksena etänätyöskentelyä, mutta oleellista olisi voida toimia tiiminä projektityöskentelyn ajan sopivissa tiloissa.
* Ennen projektityöskentelyä käydään läpi käytänteitä etäluentojen muodossa ja lokakuussa siirrytään projektityöskentely moodiin
* Lokakuussa (26.10.->) siirrytään projektityöskentelyyn. Työaikaa on käytössä kaksi päivää viikossa tiistaista 26.10 alkaen vuoden vaihteeseen asti. Keväällä työaikaa on varattu 3 päivää viikossa. Aikataulun toivotaan tiivistävän ajankäyttöä ja tehostavan työskentelyä tiimeissä. Tämä tarkoittaa tilojen ja tarvittavien resurssien riittävää ennakointia toimeksiantajalta.
* Toimeksiantajan kannattaa varmistaa, että tarvittavat tila/ohjausresurssit ovat osoitettavissa ryhmän avuksi lokakuusta alkaen.  

## Aikatauluista

**Opinnot jakaantuvat kahteen vaiheeseen**

* 7.9.-23.10.2020 Luentoja + koe + projektitiimin kasaus
* 26.10.2020-1.3.2021 Projektityöskentely alkaa
* 2.3.2021 Loppuseminaari 

# Korona-pandemian vaikutus syksyn työskentelyyn:

* Tämä tarkentuu tilanteen mukaan

## Toivomuksia mahdolliselle toimeksiantajalle

Toimeksiannot vaativat tilaajayritykseltä sitoutumista seuraaviin osa-alueisiin:

* Vaatimusmäärittelytyö yhdessä tiimin kanssa
* Tarpeellinen tekninen tuki tiimin avuksi
* Katselmointivalmius prosessien/dokumenttien suhteen sisältäen seuraavat osa-alueet: __Vaatimusmäärittely, projektisuunnitelma, testaussuunnitelma ja muu tarpeelliseksi katsottu dokumentaatio__
* Toimeksiantaja antaa käyttöön resursseja esim. pilvipalvelut/lisenssit, jos niihin on tarvetta
* Johtoryhmäkokoukset 2-3 kpl
* Tilaaja nimittää henkilön, joka on ryhmä saavutettavissa työskentelyn ajan 

**Huom!! Työskentelytilat ja tarvittavat resurssit ovat erittäin tervetulleita!**

(Aiempina vuosina ovat yritykset (esim. Qvantel, Landis&Gyr ja Digia) tarjonneet toimitilojaan opiskelijoiden käyttöön)

**Mitä toimeksiantajan kannattaa muistaa**

* Opiskelijoita ei korvamerkitä projekteihin ennakkoon! 
* Opiskelijat eivät välttämättä tunne ongelmakenttää alkuunkaan ja se vaatii perehtymistä
* Ryhmien rakennetta yritetään tasapainottaa, että kaikilla on riittävä osaamispohja annettuun toimeksiantoon 
* Varaa aikaa tiimin "ohjaukseen" muutama tunti viikossa (10h kokonaisresursseilla ei homma onnistu)
* Opiskelijatiimi tarvitsee tukea, mutta voi yllättää erittäin positiivisesti
* Hyvä ohjeistaminen ja seuranta tuo varmasti tulosta


## Mitä voi tilata?

**Millaisia projekteja on aiemmin tehty?**

* [Referenssejä aiemmilta vuosilta](projekti-referensseja.md)


Oletuksena toimeksiannosta on ohjelmisto/palvelukokonaisuus, joka vaatii suunnittelua ja perehtymistä

Tilauksen kohteena voi olla esimerkiksi:

* Tekninen PoC (Proof of Concept)
* Jonkin ohjelmiston/palvelun osa-alueen toteuttaminen vaihtoehtoisella teknologialla.
* Selvitystyö eri teknologioiden soveltuvuudesta annettuun käyttötarkoitukseen.
* Uudet Open Source -ratkaisut esim. testausautomaation parantamiseen
* Palveluprototyypit
* Ehdota omia?

## Roolit: 

* Toimeksiantajan yhteyshenkilö, joka vastaa tilaajan tehtävästä
* Toimeksiantajan henkilökunta (esim. tekninen asiantuntija, joka voi tukea tarvittaessa projektiryhmää)
* Opiskelija: (kurssille TTOS1200 osallistuva opiskelija)
* Ohjaaja/Mentor (kurssin vetäjä)
* Opiskelijatiimi, joka koostuu 5-7 opiskelijasta 
 
![](http://i.imgur.com/aNviuBf.png)

## Miten edetään eli kurssin prosessi:

* Kaikki yhteistyöstä kiinnostuneet yritysten edustajat ottavat yhteyttä ohjaajaan syyskuun alussa (marko.rintamaki@jamk.fi)
* Tehtäväantoja mietitään ennakkoon yritysten kanssa ja ne esitellään opiskelijoille syyskuun/lokakuun aikana (kurssin luentoaikona)
* Opiskelijat muodostavat ohjaajan avulla sopivat ryhmiä, joihin löytyy riittävästi kiinnostusta.
* Lopullinen valinta tapahtuu ryhmien sisällä.
* HUOM! Yritys saattaa jäädä ilman tiimiä, jos kiinnostus annettuun aiheeseen jää liian pieneksi. 

## Projektiryhmä:

* Opiskelijoiden projektiryhmä on kooltaan (5-7) henkilöä
* Yksi ryhmän jäsenistä on vastuullinen projektipäällikkyydestä (saattaa vaihtua tarpeen mukaan)
* Projektiryhmät ovat syksyn aikana perehtymismoodissa ja ei tuota mitään tuotoksia!
* Kun sopimukset, tehtävänannot ja riittävä perehtyminen on saavutettu ryhmät voivat aloittaa toimintansa
* Projektiryhmää ohjataan soveltamaan sopivia LEAN/Agile-menetelmiä
* Työlle on varattu tiivis tuotantojakso alkaen tammikuusta maaliskuuhun

## Aikataulu:

* Aloitamme ennalta sovittuina ajankohtina (syyskuussa) 
* Ryhmät tekevät valinnan ja kiinnittyvät aiheeseen (Lokakuun alusta)
* Ryhmät tekevät tilaajan kanssa mahdollisen NDA-sopimuksen, jos sille nähdään tarvetta.
* Työskentely alkaa lokakuun lopussa 
* Lokakuun aikana perehdytään toimeksiantoon ja tarvittavaan osaamiseen 
* Marraskuun aikana sopimukset ja vaatimusmäärittelydokumentaatio yhdessä tilaajan kanssa
* Maksimi käytettävä työaika projektille on ~270h X henkilöiden lukumäärä

## Ryhmän ja ohjaajan vastuut

* Ryhmä sitoutuu toimittamaan tilaajalle tuotteen sovitun vaatimusmäärittelyn pohjalta
* Tuotteella tarkoitetaan tässä tapauksessa dokumentaatiota, ohjeistusta, lähdekoodia ja testattu koontiversiota
* Ohjaaja huolehtii, että ryhmän työskentely sujuu JAMKin tiloissa ja avustaa yhteistyötä asiakaspäähän, jos sille ilmenee tarvetta 

 
## Millainen on unelmatilaus?

## Esim 1

* Yritys Z käyttää tuotannossa (Open Source) palvelua C1, joka voitaisiin integroida (Open Source) palveluun D2. Herää kysymys voisiko ryhmä opiskelijoita kehittää integraation näiden palvelujen välille? 

Ehdotus:  Tehdään projekti "C1 integraatio D2:een" ja jaetaan se avoimena GitHubissa

Ryhmä rakentaa tuotantolinjan tarpeellisista palveluista ja tuottaa Open Source -ratkaisun, jonka etenemistä valvoo toimeksiantajana edustaja.

## Esim 2

* Yritys F käyttää DFG-teknologioita muutamissa vanhemmissa tuotteissa. Olisiko mahdollista toteuttaa joitain osa-alueita uudemmalla WEB-teknologialla? Tämä vaatii kokeiluja?

Ehdotus: Tehdään projekti "Technology ASDF feasibility to replace DFG" ja kokeillaan luoda PoC-totetutus uudemmalla teknologialla. (Tulos on siis PoC) 


## No miten saan toimeksiannon mukaan kisaan? 


<iframe width="640px" height= "480px" src= "https://forms.office.com/Pages/ResponsePage.aspx?id=8Kqebvc_6U2M1B_71FlRuUxcz6FES2lCiWU_CHyl3QhUMDRXRVFGSVZKOERJUFFXQ0kzOUhJRTc3NCQlQCN0PWcu&embed=true" frameborder= "0" marginwidth= "0" marginheight= "0" style= "border: none; max-width:100%; max-height:100vh" allowfullscreen webkitallowfullscreen mozallowfullscreen msallowfullscreen> </iframe>



